module frequency(CLK,Q8,Q7,Q6,Q5,Q4b,Q4,Q3,CP6,CP5,CP4,CP3,CP2,CP1);
input CLK;
output Q8,Q7,Q6,Q5,Q4b,Q4,Q3,CP6,CP5,CP4,CP3,CP2,CP1;
reg QA,QB,QC,QD;
reg T4,T5;
reg PA,PB;
wire five;

always@(posedge CLK) // 74161
	begin
	if(QC)
		begin
		QA = 0;
		QB = 0;
		QC = 0;
		end
	else
		begin
		QA = ~QA;
		if(!QA)
			begin
			QB = ~QB;
			if(!QB)
				begin
				QC = ~QC;
				end
			end
		end
	end

assign five = ~(QA | QB | QC);
assign Q3 = five;

always@(posedge five)
	T4 <= ~T4;
assign Q4 = T4;
assign Q4b = ~T4;

always@(posedge T4)
	T5 <= ~T5;
assign Q5 = T5;

always@(posedge Q5) // 74161
	begin
	if(PB)
		begin
		PA = 0;
		PB = 0;
		end
	else
		begin
		PA = ~PA;
		if(!PA)
			PB = ~PB;
		end
	end

assign Q8 = ~(PA | PB);
assign Q6 = PA;
assign Q7 = PB;

assign CP1 = Q4b & Q5 & Q6;
assign CP2 = Q4b & ~Q5 & Q6;
assign CP3 = Q4b & Q5 & ~Q6 & Q7;
assign CP4 = Q4b & ~Q5 & ~Q6 & Q7;
assign CP5 = Q4b & Q5 & ~Q6 & ~Q7;
assign CP6 = Q4b & ~Q5 & ~Q6 & ~Q7;

endmodule
